<template>
  <card :title="project === null ? '' : `Проект '${project.name}'`">
    <!-- <template #after-title>
      <prime-button label="Запросить быстрые результаты" @click="getFastResult" />
    </template> -->
    <div class="project-filters">
      <div class="form-field">
        <label for="monthpicker">Месяци и год</label>
        <prime-calendar
          id="monthpicker"
          v-model="date"
          view="month"
          date-format="mm/yy"
          :selection-mode="datePickerType"
        />
      </div>

      <div class="project-filters__filter">
        <prime-checkbox
          id="datepicker-type"
          v-model="isRangeDatepicker"
          binary
        />
        <label for="datepicker-type">Режим выбора "Период"</label>
      </div>

      <div class="form-field">
        <label for="competitor-dropdown">Выберите проект или конкурента</label>

        <prime-dropdown
          v-model="competitor"
          label="competitor-dropdown"
          :options="competitors"
          option-label="domain"
          :filter="true"
        />
      </div>

      <div class="form-field">
        <label for="group-multi-select">Выберите группы</label>

        <keyword-group-multi-select
          v-model="keywordGroups"
          label="group-multi-select"
          :groups="keywordGroupsSelected"
        />
      </div>

      <div class="form-field">
        <label for="group-multi-select">Включить ключевые слова</label>

        <keyword-multi-select
          v-model="keywordsIncluded"
          label="group-multi-select"
          :keywords="project === null ? [] : project.keywords"
          :groups="keywordGroupsSelected"
        />
      </div>

      <div class="form-field">
        <label for="group-multi-select">Исключить ключевые слова</label>

        <keyword-multi-select
          v-model="keywordsExcluded"
          label="group-multi-select"
          :keywords="project === null ? [] : project.keywords"
          :groups="keywordGroupsSelected"
        />
      </div>

      <div class="project-filters__filter">
        <prime-button @click="submitFilters">Принять</prime-button>
      </div>
    </div>

    <div>
      <prime-button @click="downloadCsv">Скачать CSV</prime-button>
    </div>

    <div v-if="project !== null">
      <project-info-by-keywords
        v-if="!isDateArray"
        ref="project"
        :keywords="keywords"
        :number-of-days-in-month="numberOfDaysInMonth"
        :project="project"
      />
      <project-info-tops
        v-else-if="topResultReply !== null"
        ref="project"
        :date="selectedDate"
        :top-results="topResultReply"
      />
    </div>
  </card>
</template>

<script lang="ts">
import { parse } from 'json2csv';
import PrimeButton from 'primevue/button/Button.vue';
import PrimeCalendar from 'primevue/calendar/Calendar.vue';
import PrimeCheckbox from 'primevue/checkbox/Checkbox.vue';
import PrimeDropdown from 'primevue/dropdown/Dropdown.vue';
import { defineComponent } from 'vue';
import { getKeywords, fastResult, getTopResult } from '@/api/handler/keywords';
import { getProject } from '@/api/handler/projects';
import { GetKeywordsArgs, TopResultArgs, TopResultReply } from '@/api/keywords';
import Card from '@/components/Card.vue';
import KeywordGroupMultiSelect from '@/components/KeywordGroupMultiSelect.vue';
import KeywordMultiSelect from '@/components/KeywordMultiSelect.vue';
import ProjectInfoByKeywords from '@/components/projectView/ProjectInfoByKeywords.vue';
import ProjectInfoTops from '@/components/projectView/ProjectInfoTops.vue';
import { Competitor } from '@/models/competitors';
import { KeywordGroup } from '@/models/keywordGroup';
import { KeywordExtended, KeywordWithRelations } from '@/models/keywords';
import { ProjectExtendedWithGroups } from '@/models/projects';

type Type = string | null | (string | null)[];

const parseNumber = (data: Type, defaultValue: number): number => {
  let value = defaultValue;
  if (typeof data === 'string') {
    const parseResult = parseInt(data, 10);
    if (isFinite(parseResult)) {
      value = parseResult;
    }
  }
  return value;
};

const parseNumberPositive = (data: Type, defaultValue: number): number => {
  let value = defaultValue;
  const parseResult = parseNumber(data, defaultValue);
  if (parseResult >= 0) {
    value = parseResult;
  }
  return value;
};

const getNumberOfDaysInMonth = (date: Date): number => {
  const newDate = new Date(date);

  newDate.setDate(1);
  const newDate2 = new Date(newDate);

  newDate2.setMonth(newDate.getMonth() + 1);

  return (newDate2.getTime() - newDate.getTime()) / 1000 / 60 / 60 / 24;
};

function isNotNullArray<T>(arr: (T | null)[]): arr is T[] {
  return arr.every(item => item !== null);
}

interface Data {
  project: ProjectExtendedWithGroups | null;
  keywords: KeywordExtended[];
  topResultReply: TopResultReply | null;
  date: Date | (Date | null)[] | null;
  selectedDate: Date | (Date)[];
  competitor: Competitor | null;
  isRangeDatepicker: boolean;
  keywordGroups: KeywordGroup[] | null;
  keywordsIncluded: KeywordWithRelations[] | null;
  keywordsExcluded: KeywordWithRelations[] | null;
}

export const randomHexColor = (): string => {
  const MIN = 100;
  const MAX = 200;
  const randomInt = (min: number, max: number): number => Math.floor(min + Math.random() * (max + 1 - min));

  const rgb = Array(3)
    .fill(0)
    .map(() => {
      const value = randomInt(MIN, MAX).toString(16);
      return value.length < 2 ? `0${value}` : value;
    });

  return `#${rgb.join('')}`;
};

export default defineComponent({
  name: 'project-view',
  components: {
    PrimeButton,
    PrimeCheckbox,
    PrimeCalendar,
    PrimeDropdown,
    Card,
    ProjectInfoByKeywords,
    ProjectInfoTops,
    KeywordGroupMultiSelect,
    KeywordMultiSelect,
  },
  data(): Data {
    return {
      project: null,
      keywords: [],
      topResultReply: null,
      date: new Date(),
      selectedDate: new Date(),
      competitor: null,
      isRangeDatepicker: false,
      keywordGroups: null,
      keywordsIncluded: null,
      keywordsExcluded: null,
    };
  },
  computed: {
    datePickerType(): 'range' | 'single' {
      return this.isRangeDatepicker ? 'range' : 'single';
    },
    args(): GetKeywordsArgs | TopResultArgs | null {
      if (this.date === null || this.project === null) {
        return null;
      }

      const competitorID = this.competitor === null || this.competitor.id === -1 ? null : this.competitor.id;
      const id = this.project.id;

      if (Array.isArray(this.date)) {
        if (!isNotNullArray(this.date)) {
          return null;
        }

        const startMonth = this.date[0].getMonth() + 1;
        const startYear = this.date[0].getFullYear();
        const endMonth = this.date[1].getMonth() + 1;
        const endYear = this.date[1].getFullYear();

        return {
          startYear,
          startMonth,
          endYear,
          endMonth,
          id,
          competitor: competitorID ?? undefined,
          groups: this.keywordGroups === null ? [] : this.keywordGroups.map(group => group.id),
          keywordsExcluded: this.keywordsExcluded === null ? [] : this.keywordsExcluded.map(group => group.id),
          keywordsIncluded: this.keywordsIncluded === null ? [] : this.keywordsIncluded.map(group => group.id),
        };
      }
      const month = this.date.getMonth() + 1;
      const year = this.date.getFullYear();

      return {
        year,
        month,
        id,
        competitorID: competitorID ?? undefined,
        groups: this.keywordGroups === null ? [] : this.keywordGroups.map(group => group.id),
        keywordsExcluded: this.keywordsExcluded === null ? [] : this.keywordsExcluded.map(group => group.id),
        keywordsIncluded: this.keywordsIncluded === null ? [] : this.keywordsIncluded.map(group => group.id),
      };
    },
    competitors(): Competitor[] {
      if (this.project === null) {
        return [];
      }
      const competitors: Competitor[] = [
        {
          id: -1,
          domain: this.project.domain,
        },
      ];

      for (const item of this.project.competitors) {
        competitors.push(item);
      }
      return competitors;
    },
    keywordGroupsSelected(): KeywordGroup[] {
      if (this.project === null) {
        return [];
      }

      return this.project.groups.map(group => group);
    },
    numberOfDaysInMonth(): number {
      if (this.selectedDate === null || Array.isArray(this.selectedDate)) {
        return -1;
      }
      return getNumberOfDaysInMonth(this.selectedDate);
    },
    isDateArray(): boolean {
      return Array.isArray(this.selectedDate);
    },
  },
  watch: {
    datePickerType() {
      if (this.datePickerType === 'range') {
        this.date = null;
      } else {
        this.date = new Date();
      }
    },
  },
  async mounted() {
    const idStr = this.$route.params.id;

    const id = parseNumberPositive(idStr, 0);
    const res = await getProject({ id });

    if (res.__state === 'success') {
      this.project = res.data;
      this.competitor = {
        id: -1,
        domain: this.project.domain,
      };
    }
    this.submitFilters();
  },
  methods: {
    async downloadCsv() {
      if (this.$refs.project === undefined) {
        return;
      }

      const project: any = this.$refs.project;
      const searchEngines = ['google.com', 'yandex.ru'];
      const tableData = [];
      const fields = project.columns.map((column: any) => column.field);
      for (const searchEngine of searchEngines) {
        tableData.push({ keyword: searchEngine });
        const values = [];
        for (const data of project.tableData[searchEngine]) {
          const newValue: any = {};
          for (const key of fields) {
            console.log(data[key], key);
            newValue[key] = data[key] === undefined || data[key] === '' ? '-' : data[key].toString().replace('.', ',');
          }
          values.push(newValue);
        }
        tableData.push(...values);
      }

      const file = parse(tableData, {
        fields,
        delimiter: ';',
        withBOM: true,
      });

      const link = document.createElement('a');
      const encodedUri = `${encodeURI('data:text/csv;charset=utf-8,')}${encodeURIComponent(file)}`;

      link.href = encodedUri;
      link.download = 'Файл';
      link.click();

    },
    async submitFilters() {
      if (this.args === null || this.args.id === -1) {
        return;
      }
      if (this.date instanceof Date) {
        this.selectedDate = new Date(this.date);
      } else if (Array.isArray(this.date) && isNotNullArray(this.date)) {
        this.selectedDate = [...this.date];
      }

      if ('year' in this.args) {
        const res1 = await getKeywords({ ...this.args });

        if (res1.__state === 'success') {
          this.keywords = res1.data;
        }
      } else {
        const res1 = await getTopResult({ ...this.args });
        if (res1.__state === 'success') {
          this.topResultReply = res1.data;
        }
      }

    },
    async getFastResult() {
      if (this.project === null) {
        return;
      }
      const res = await fastResult({ id: this.project.id });

      if (res.__state === 'success') {
        this.keywords = res.data;
      }
    },
  },
});
</script>
<style lang="scss">
.project-filters {
  display: flex;
  column-gap: 1.5em;
  flex-wrap: wrap;

  &__filter {
    display: flex;
    gap: 10px;
    justify-content: center;
    align-items: center;
  }
}

.project-table {
  overflow: auto;
}

.project-card {

  &_chart {
    position: relative;
    height: 500px;
  }

  &:not(:last-child) {
    margin-bottom: 1em;
  }

  &_full-height {
    position: fixed;
    top: 0;
    left: 0;
    z-index: 500;
    width: 100vw;
    height: 100vh;
  }

  &__title {
    display: flex;
    align-items: center;
    justify-content: space-between;
  }
}

.project-keyword {
  min-width: 150px;
  max-width: 150px;
}

.project-top {
  min-width: 70px;
  max-width: 70px;
  overflow: hidden;
}

.project-by-day {
  min-width: 50px;
  max-width: 50px;
  overflow: hidden;
}
</style>
